﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _2012_06_05
{
    abstract class Bilanzposten
    {
        double wert;
        public double Wert
        {
            get { return wert; }
            set { wert = value; }
        }
        TimeSpan abschreibungsdauer;
        public abstract void Accept(Visitor visitor);
    }

    class Gebäude : Bilanzposten
    {
        public override void Accept(Visitor visitor)
        {
            visitor.Visit(this);
        }
    }

    class Fahrzeug : Bilanzposten
    {
        public override void Accept(Visitor visitor)
        {
            visitor.Visit(this);
        }
    }

    abstract class Visitor
    {
        public abstract void Visit(Gebäude g);
        public abstract void Visit(Fahrzeug f);
    }

    class Abschreibung : Visitor
    {
        public override void Visit(Gebäude g)
        {
            g.Wert *= 0.9; 
        }

        public override void Visit(Fahrzeug f)
        {
            f.Wert *= 0.75;
        }
    }

    class Bilanzsumme : Visitor
    {
        double summe;

        public override void Visit(Fahrzeug f)
        {
            summe += f.Wert;
        }

        public override void Visit(Gebäude g)
        {
            summe += g.Wert;
        }
    }
}
